/* ___________________________________________________________________________

    Module: insertRegister.js   Version: v0.2
    Author: Guillermo Peña (guillermo.pena.cardano@gmail.com)
    Last update: 08/08/2013
    
        Save a new register in a collection

______________________________________________________________________________*/



// __ Modules _____________________________________________________________

var util       = require("util")
var uuid 	   = require("node-uuid")
var clone  	   = require('clone')
var valMon     = require("../lib/valMon.js")
var EasyWizard = require("../node_modules/easywizard/lib/easyWizard.js")

process.on('uncaughtException', function(err) { console.error(err.stack) })

// __ Private Methods _____________________________________________________

var adaptData = function(data) {

	var dataArray = []
	var firstChar = data.charAt(0)  
	var lastChar  = data.charAt(data.length - 1)  

	// Removing blancks
	o.value = o.value.replace(new RegExp('[ ]+[,]', 'g'), ",")	
	o.value = o.value.replace(new RegExp('[,][ ]+', 'g'), ",")

	// If data is an array
	var array = o.value.split(",")
	if (array.length > 1) {
		array.forEach( function(item){ 
					if ( parseInt(item,10) ) item = parseInt(item,10)
					dataArray.push(item) 
				})
		return dataArray

	// If data is a single data
	} else {
		if ( parseInt(data,10) ) data = parseInt(data,10)
		return data
	}
}


var prepareEvents = function(id) {
	vm.emitter.once('valmon:' + id + ':insert:done', function() {
		console.log("\n  Register inserted");
		ew.emitter.emit('continue')
	})
	vm.emitter.once('valmon:' + id + ':insert:validate:nok',  function() { ew.emitter.emit('continue') })
	vm.emitter.once('valmon:' + id + ':insert:error', 		  function() { error = true })
	vm.emitter.once('valmon:' + id + ':insert:connect:error', function() { error = true })
	vm.emitter.once('valmon:' + id + ':find:error', 		  function() { error = true })
	vm.emitter.once('valmon:' + id + ':find:connect:error',	  function() { error = true })
}

// __ Main Object _________________________________________________________

var ew = new EasyWizard()
var o  = ew.getObject()
o.register = new Object()

var vmJson = { dbname:"test", server:"localhost", port:27017, collection:"validations", logLevel:1}
var vm = new valMon(vmJson)
id = uuid.v4().substring(0, 5)

// Events 
var error = false
ew.emitter.once('end', function() { console.log("\nThanks for use insertRegister v1.0\n")})
prepareEvents(id)


ew.emitter.on('paused', function() {

	var o = ew.getObject()
	var currentStep = ew.getCurrentStep()

	// Adding property
	if ( currentStep == 2 ) {
		o.value = adaptData(o.value)
		o.register[o.property.trim()] = o.value
		o.property = undefined
		o.value = undefined
	}

	// Saving register
	if ( currentStep == 3 && ew.getNextStep() == 4 ) {
		console.log("\n  Saving register in collection '" + o.collection + "': " + util.inspect(o.register))
		vm.insert(id, o.collection, o.register)
		o.register = new Object()
	} else {
		if (error !== true ) ew.emitter.emit('continue')
	}

	// Reseting register
	if ( currentStep == 4 ) {
		o.register = new Object()
		vm = new valMon(vmJson)
		id = uuid.v4().substring(0, 5)
		prepareEvents(id)
	}
})

var wizardFile = "./insertRegister.wizard"
ew.run(wizardFile)