/* ___________________________________________________________________________

    Module: mongoDaoTest.js   Version: v0.2
    Author: Guillermo Peña (guillermo.pena.cardano@gmail.com)
    Last update: 04/08/2013

______________________________________________________________________________*/



// __ Modules _____________________________________________________________

var util     = require("util")
var uuid 	 = require("node-uuid")
//var events   = require('events')
var mongoDao = require("../lib/mongoDao.js")

//var emitter  = new events.EventEmitter // Event emitter
var dao  = new mongoDao({'dbname':"test", 'server':"localhost", 'port':27017, 'logLevel':2})

// __ Test 01 : Find test (OK) ____________________________________________


var id0   = uuid.v4().substring(0, 5)
var args = { 'id'        : id0
		   , 'collection': "animales"
		   , 'filters'	 : { 'color': "blanco"}
		   , 'logLevel'  : dao.getLogLevel
		   , 'extras'	 : {}
		   }

dao.emitter.on('mongodao:' + id0 + 'connect:error',
				function(err) { console.log('  MongoDao : ' + id0 + ' : connect : Error : ' + err) })

dao.emitter.on('mongodao:' + id0 + 'find:error', 
				function(err) { console.log('  MongoDao : ' + id0 + ' : find : Error : ' + err) })

dao.emitter.once('mongodao:' + id0 + ':find:done', 
				 function(registers) { console.log("\n  Registers found:\n" + util.inspect(registers)) })

dao.find(args, function(){})


// __ Test 02 : Inserting test (OK) ____________________________________________


var id1   = uuid.v4().substring(0, 5)
var args = { 'id'        : id1
		   , 'collection': "animales"
		   , 'register'	 : { 'especie': "dragon", 'color': "rojo", 'fuego':true}
		   , 'logLevel'  : dao.getLogLevel
		   , 'extras'	 : {}
		   }

dao.emitter.on('mongodao:' + id1 + ':connect:error',
				function(err) { console.log('  MongoDao : ' + id1 + ' : connect : Error : ' + err) })

dao.emitter.on('mongodao:' + id1 + ':insert:error', 
				function(err) { console.log('  MongoDao : ' + id1 + ' : insert : Error : ' + err) })

dao.emitter.once('mongodao:' + id1 + ':insert:done', 
				 function() { console.log('  MongoDao : ' + id1 + ' : insert : Register inserted') })

dao.insert(args, function(){})


// __ Test 03 : Removeing test (OK) ____________________________________________


id2   = uuid.v4().substring(0, 5)
var args = { 'id'        : id2
		   , 'collection': "animales"
		   , 'filters'	 : { 'especie': "dragon" }
		   , 'logLevel'  : dao.getLogLevel()
		   , 'extras'	 : {}
		   }

dao.emitter.on('mongodao:' + id2 + ':connect:error',
				function(err) { console.log('  MongoDao : ' + id2 + ' : connect : Error : ' + err) })

dao.emitter.on('mongodao:' + id2 + ':remove:error', 
				function(err) { console.log('  MongoDao : ' + id2 + ' : remove : Error : ' + err) })

dao.emitter.once('mongodao:' + id2 + ':remove:done', 
				 function() { console.log('  MongoDao : ' + id2 + ' : remove : Register removed') })

dao.remove(args, function(){})

